/***************************************************************
*
*  (c) 2013 Slavistik-Portal (slavistik-portal@sbb.spk-berlin.de)
*
***************************************************************/
/**
 * Widget for Solr-Index 
 * More information: https://slavistik-portal.de/widgets.html
 *
 * @author		Vladimir Neumann <vladimir.neumann@sbb.spk-berlin.de>
 * @date		January 2019
 * @version 	0.6
 *
 */
 
var totalRec = 0;   
var recPerPage = 10;
var recStart = 0;
var curPage = 1;
var onside = 6;
var filterQuery =[];
var filterQueryPref =[];
var hlf = 'content';

$(document).ready(function(){
	document.search.onsubmit = onFormSubmitEventHandler;

});
	   
// when search button pressed
function onFormSubmitEventHandler() 
{
    resetPage();
    triggerSearch();
    return false;
}	   
	   
function resetPage()
{
    curPage = 1;
    recStart = 0;
	document.getElementById('pager').innerHTML = '';
}
	   
function triggerSearch(){
	var event = 'FormSubmit';
	var query = $('#query').val();
	//var url = 'https://slavistik-guide.de/widget/slavica/select?'
	var url = 'https://slavistik-guide.de/widget/fullt/select?'
		+ 'q='+ encodeURIComponent(query)
		+ '&df='+hlf
		+ '&start=' + recStart
		+ '&rows=' + recPerPage
		+ '&wt=json&json.wrf=?'
		+ '&hl.fl=' + hlf
		+ '&hl=on'
		+ '&hl.fragsize=200'
		// https://lucene.apache.org/solr/guide/6_6/highlighting.html#Highlighting-TheOriginalHighlighter
		+ '&hl.method=original'
		+ '&hl.maxAnalyzedChars=-1' // bei original immer maxAnalyzedChars angeben, bei unified NICHT
		//+ '&hl.method=unified'
		+ '&hl.snippets=5'
		//+ '&hl.tag.pre=<mark>'
		//+ '&hl.tag.post=</mark>'
		+ '&hl.simple.pre=<mark>'
		+ '&hl.simple.post=</mark>'
		//+ '&hl.regex.slop=0.4'
		+ '&facet=true'
		+ '&facet.limit=15'
		+ '&facet.mincount=1'
		+ '&facet.field=year'
		+ '&facet.field=language'
		+ '&facet.field=medium'
		+ '&facet.field=stitle'
		+ '&fq='+getFacetQuery();		
	//console.log(url);
	$.getJSON(url, processResult);
	
	// Stats 
	var device = 'Fullt';
	if ( curPage > 1 ) { event = 'PageNum ' + curPage;}
	if ( !jQuery.isEmptyObject(filterQuery)) { event = "Facet: " + filterQuery.join();}
	$.get("https://slavistik-guide.de/widget/stats/track.php", { value: query, event: event, category: "Search", device: device, tmp: $.now() } );
}
			
function triggerSpell(){
	var query = $('#query').val();
	var url = 'https://slavistik-guide.de/widget/fullt/spell?'
		+ 'q=' + encodeURIComponent(query.toLowerCase(query))
		+ '&start=0'
		+ '&rows=0'
		+ '&wt=json&json.wrf=?'
		+ '&qt=spellchecker'
		+ '&spellcheck=true&spellcheck.extendedResults=false'
	//console.log(url);
	if (query != '') { $.getJSON(url, drawSpellcheck);}
}

			
function processResult(data){

	totalRec = data.response.numFound;
	document.getElementById('hits').innerHTML = '';
	document.getElementById('hits').innerHTML = 'Treffer: <b>' + totalRec + '</b>';
    document.getElementById('spell').innerHTML = '';
	document.getElementById('results').innerHTML = '';	
	
	if (totalRec > 0) {
	drawPager();
	 } else {
		 document.getElementById('pager').innerHTML = '';
		 document.getElementById('pager_down').innerHTML = '';
		 triggerSpell();
	 }

			
			var details ='';
			
			var highlight = jQuery.makeArray(data.highlighting);
			//console.log(highlight);
			//console.log(highlight[0][247262].text[0]);
				
			$.each(data.response.docs, function(key, value) {

			details += '<div class="details"><table class="table table-bordered table-striped"><colgroup width="120"></colgroup>';

			if (value.id  != undefined) {
				details += '<tr><td class ="rt">ID</td><td>' + value.id;
				details += '</td></tr>';
			}
			
			if (value.title != undefined) {
				details += '<tr><td class ="rt">Titel</td><td><b>' + value.title + '</b>';
				details += '</td></tr>';
			}

			if (value.author != undefined) {
				details += '<tr><td class ="rt">Autor</td><td>' + value.author;
				details += '</td></tr>';
			}			
			
			if (highlight[0][value.id].content[0] != undefined) {
				details += '<tr><td class ="rt">Beschreibung</td><td>... ' + highlight[0][value.id].content.join(' ... ') + ' ...';
				details += '</td></tr>';
	           
			}
						

			if (value.note != undefined) {
				details += '<tr><td class ="rt">Anmerkung</td><td>' + value.note;
				details += '</td></tr>';
			}
			
			if (value.year != undefined) {
				details += '<tr><td class ="rt">Jahr</td><td>' + value.year;
				details += '</td></tr>';
			}	

			if (value.language != undefined) {
				details += '<tr><td class ="rt">Sprache</td><td>' + value.language;
				details += '</td></tr>';
			}			
			
			if (value.medium != undefined) {
				details += '<tr><td class ="rt">Medium</td><td>' + value.medium;
				details += '</td></tr>';
			}
			
			if (value.origin != undefined) {
				details += '<tr><td class ="rt">Quelle</td><td>' + value.origin;
				if (value.stitle != undefined) {
					details += ', ' + value.stitle;
				}
				details += '</td></tr>';
			}			
			
			if (value.url != undefined) {
				details += '<tr><td class ="rt">Quelle-URL</td><td><a href="' + value.url + '" target="_blank">URL</a>';
				details += '</td></tr>';
			}		


			
			  details += '</table></div><br>';
			

			});
			
			document.getElementById('results').innerHTML = details;			
			drawFacets(data, 'stitle', 'ShortTitle', '1');
			drawFacets(data, 'medium', 'Medientyp', '2');
			drawFacets(data, 'language', 'Sprache', '3');
			drawFacets(data, 'year', 'Jahr', '4');
		
}
		
function drawFacets(data, name_f, title_f, order_f){

			document.getElementById('facets_'+order_f).innerHTML = '';	
			var facets ='';
			
			$.each(data.facet_counts, function(key, value) {
			//console.log(value);
			
			if (value[name_f] != undefined && value[name_f].length != 0) {
			facets += '<p class="facets_t">'+ title_f +'</p>';
			  for (fnum = 0; fnum < value[name_f].length; fnum++) {
			  facets += '<div class="facetitem">';
			  
			  if (jQuery.inArray(value[name_f][fnum], filterQuery) != '-1') {	
				  facets += '<a href="#" class="crossout" '+name_f+'="' + value[name_f][fnum] + '" onclick="defilterFacet(\''+name_f+'\', this.getAttribute(\''+name_f+'\'));return false;">' + value[name_f][fnum] + '</a>';
					fnum++;
				  facets += " <span>" + value[name_f][fnum] + "</span> [<strong style=\"color: red;\">Filter</strong>]";
			  } else {
				  facets += '<a href="#" '+name_f+'="' + value[name_f][fnum] + '" onclick="filterFacet(\''+name_f+'\', this.getAttribute(\''+name_f+'\'));return false;">' + value[name_f][fnum] + '</a>';
					fnum++;
				  facets += " <span>" + value[name_f][fnum] + "</span>";			  
			  }
			  
			  facets += '</div>';
			  }
			  
			}
			
			
			document.getElementById('facets_'+order_f).innerHTML = facets;
			
			});
}

function drawSpellcheck(data){

			document.getElementById('spell').innerHTML = '';
			var spell ='';
			
			$.each(data.spellcheck.suggestions, function(key, value) {
			
			//console.log(value);
			
			if (value.suggestion != undefined) {
			
			var suggestionItems = '';
				for (var i = 0; i < value.suggestion.length; ++i) {
				suggestionItems += '<a href="#" suggestionItem_id="' + value.suggestion[i] + '" onclick="suggestionToQuery(this.getAttribute(\'suggestionItem_id\'));return false;">' + value.suggestion[i] + '</a> ';
					}
			  spell += 'Did you mean: ' + suggestionItems + ' ?';
			  	  
			}
			
			document.getElementById('spell').innerHTML = spell;

			
			});
}

function suggestionToQuery(value){
	document.search.query.value = value;
	filterQuery = [];
	filterQueryPref = [];
	triggerSearch();
}
			
function showPage(i){
	curPage = i;
	recStart = (i - 1)*recPerPage;
	triggerSearch();
}
		
function pagerNext(i){
	curPage = i;
	recStart = i*recPerPage;
	triggerSearch();
}

function filterFacet(pref, value){
	filterQuery.push(value);
	filterQueryPref.push(pref);
	//console.log(pref);
	curPage = 1;
	recStart = 0;
	triggerSearch();
}

function defilterFacet(pref, value){
	filterQuery.splice(jQuery.inArray(value,filterQuery), 1);
	filterQueryPref.splice(jQuery.inArray(pref,filterQueryPref), 1);
	curPage = 1;
	recStart = 0;
	triggerSearch();
}

function getFacetQuery(){
	if (filterQuery.length > 0) {
		var filterQueryURL = '';
		for (var i = 0; i < filterQuery.length; ++i) {
		filterQueryURL	+= filterQueryPref[i] + ':"' + encodeURIComponent(filterQuery[i]) + '"+';
		}
		return filterQueryURL;
	} else {
	return '';
	}
}
		
function drawPager(){

		document.getElementById('pager').innerHTML = '';
		document.getElementById('pager_down').innerHTML = '';
		var pager ='';
		var numLabel ='';
		var pages = Math.ceil(totalRec / recPerPage);
			pager = '<nav><ul class="pagination">';
			if ((curPage - onside) < 1 ) { is = 1;} else {is = (curPage - onside);}
			
			if ((curPage - onside) > 1) {
				pager += '<li><a href="#" id="next" onclick="pagerNext('+(curPage - 1)+')">«</a><li>';
			}
				
			for(var i = is ; i <= pages && i <= (curPage + onside); i++) {
			if(i == curPage) {numLabel = " class=\"active\"";}
				
			pager += '<li' + numLabel + '><a href="#" onclick="showPage('+i+')">' + i + '</a></li>';
			var numLabel ='';
			}
			
			if (pages - (curPage + onside) > 0) {
				pager += '<li><a href="#" id="next" onclick="pagerNext('+(curPage + 1)+')">»</a></li>';
			}

				
			pager += '</ul></nav>';
			
			if (totalRec > 5) {
			document.getElementById('pager').innerHTML = pager;
			if (totalRec - recStart > 5) { document.getElementById('pager_down').innerHTML = pager; }
			}
		    
			//console.log(pages);		
}